#ifndef COMPLEXE_HPP
#define COMPLEXE_HPP

#include <cmath>
#include <iostream>
using namespace std;

class complexe {
  double r;
  double i;
public:
  complexe (){
    r = 0;
    i = 0;
    cout<<" constructeur par complexe par défaut "<<endl;
  }
  complexe (double reel , double img){
    r = reel;  i = img;
  }
  complexe (const complexe & x){
    r = x.r;  i = x.i;
     cout<<" constructeur par copie complexe par défaut "<<endl;
  }
  ~complexe (){
    cout<<" destructeur complexe "<<endl;
  }
  bool reel_pure();
  bool img_pure();
  complexe modify_reel(double reel);
  complexe  modify_img(double img);
  double  module();
  complexe conjugue();
  double reel() const;
  double img() const;
  complexe operator + (complexe);
  complexe operator - ( complexe);
  complexe operator * ( complexe);
  complexe operator / ( complexe);
  complexe & operator = (const complexe &);
  bool operator < (complexe);
  bool operator > (complexe);
  bool operator == (complexe);
  bool operator != (complexe);
  friend ostream & operator<<(ostream &, const complexe &);
  friend complexe operator *(double, const complexe &);
  int testu_1();
  int testu_2();
  int testu_3();
  int all_testsu();
};

class comp_unite : public complexe {
  double theta;
public:
  comp_unite (){ // fait automatiquement
    theta =0;
  }
  comp_unite (double tinit): complexe(cos(tinit),sin(tinit)){
    theta = tinit;
  }
  comp_unite (const comp_unite & x): complexe(x){
     theta = x.theta; 
  }
  ~comp_unite (){
  }
  comp_unite modify_theta(double theta);
  comp_unite modify_reel(double reel);
  comp_unite  modify_img(double img);
  double  module();
  comp_unite eval();
  comp_unite conjugue();
  comp_unite operator * ( comp_unite);
  comp_unite & operator = (const comp_unite &);
};



#endif
