#include <cmath>
#include <iostream>
#include "complexe2.hpp"

using namespace std;

bool complexe2::reel_pure(){
  bool res = false;
  if( i == 0.0) { res = true; }
  return res;
};
bool complexe2::img_pure(){
  bool res = false;
  if( r == 0.0) { res = true; }
  return res;
};

double complexe2::module(){
  //cout<<" module classe héritée "<<endl;
  return sqrt(r*r+i*i);
};

complexe2 complexe2::conjugue(){
  complexe2 res;
  res.r = r;
  res.i = -i;
  return res;
} 

complexe2 complexe2::modify_reel(double reel){
  r = reel;
  return *this;
};
complexe2 complexe2::modify_img(double img){
  i = img;
  return *this;
};

double complexe2:: reel() const{
  return r;
}
double complexe2:: img() const{
  return i;
}

complexe2 complexe2:: operator + (complexe2 x){
  complexe2 res;
  res.r = r+x.r;
  res.i = i+x.i;
  cout<< " le + complexe "<<endl;
  return res;
};

complexe2 complexe2:: operator * (complexe2 x){
  complexe2 res;
  cout<<" multiplication classe mère " <<endl;
  res.r = r*x.r-i*x.i;
  res.i = r*x.i+i*x.r;
  return res;
};

complexe2 complexe2:: operator - (complexe2 x){
  complexe2 res;
  res.r = r-x.r;
  res.i = i-x.i;
  return res;
};

complexe2 complexe2 :: operator / (complexe2 x){
  complexe2 res;
  double mod;
  mod = this->module();
  res.r = (r*x.r+i*x.i)/(mod*mod);
  res.i = (i*x.r-x.i*r)/(mod*mod);
  return res;
};

complexe2 & complexe2:: operator = (const complexe2 & x){
  if(&x != this){
    r = x.r;
    i = x.i;
  }
  cout<< " le = complexe "<<endl;
  return *this;
};

bool complexe2:: operator < (complexe2 x){
  bool res = false;
  if(this->module() < x.module() ) { res = true;}
  return res;
};

bool complexe2:: operator > (complexe2 x){
  bool res = false;
  if(this->module() > x.module()) { res = true;}
  return res;
};

bool complexe2:: operator == (complexe2 x){
  bool res = false;
  if(this->module() == x.module()) { res = true;}
  return res;
};

ostream & operator<<(ostream & out, const complexe2 & x){
  out<<x.r<<"+i "<<x.i;
  return out;
}		   

complexe2 operator *(double a, const complexe2 & x){
  complexe2 res;
  res.r = a*x.r;
  res.i = a*x.i;
  return res;
}

int complexe2:: testu_1(){
  complexe2 x1(1,1);
  complexe2 x2(1,-2);
  double mod=0.0;
  
  *this = x1;
  *this = *this + x2 ; // *this = 2 -i
  x1 = x1.conjugue(); // x1  = 1 - i
  *this = *this * x1 ; // *this = 1 -3i
  mod = this->module(); // sqrt(10)
  *this = *this / x1; // *this = (1-3i)/(1-i) = (4- 2i)/2
  *this = (mod*mod) * (*this); // *this = 5(4-2i)

  if(this->reel() == 20 && this->img() == -10) { return 0; }
  else { return 1; }
}

int complexe2:: testu_2(){
  complexe2 x1(1,1);
  bool a=false,b=false,c=false,d=false;
  
  *this = x1;
  a= this->reel_pure();
  b= this->img_pure();
  this->modify_reel(0.0);
  c = this->img_pure();
  this->modify_reel(1.0);
  this->modify_img(0.0);
  d = this->reel_pure();

  if( a+b+c+d == 2) { return 0; }
  else { return 1; }

  return 0; 
}

int complexe2:: testu_3(){
  complexe2 x1(1,1);
  complexe2 x2(1,2);
  complexe2 x3(sqrt(2.0),0.0);
  bool a=false,b=false,c=false;

  *this = x1;
  a = (*this < x2);
  b = (x2 > *this);
  c = (x3 == *this);
  if( a+b+c == 3) { return 0; }
  else { return 1; }

  return 0; 
}

int complexe2:: all_testsu(){
  int c=0,t=0;
  complexe2 x;
  c=x.testu_1(); t = t +c;
  c=x.testu_2(); t = t +c;
  c=x.testu_3(); t = t +c;
  cout<<"Tests unitaires réussis, classe rationnel: "<<3-t<<"/3"<<endl;
  return 0;
}

comp_unite2 comp_unite2::eval(){
  r=cos(theta);
  i=sin(theta);
  return *this;
}

comp_unite2 comp_unite2::modify_theta(double thetanew){
   theta = thetanew;
   this->eval();
   return *this;
}


comp_unite2 comp_unite2::conjugue(){
  comp_unite2 res;
  theta = -theta;
  res.eval();
  return res;
}

comp_unite2 comp_unite2::operator * ( comp_unite2 x){
  comp_unite2 res;

  res.theta = theta+x.theta;
  res.eval();
  return res;
}

comp_unite2 & comp_unite2::operator = (const comp_unite2 & x){
    if(&x != this){
      r=x.r;
      i=x.i;
      theta = x.theta; }
   return *this;
}


