#ifndef COMPLEXE2_HPP
#define COMPLEXE2_HPP

#include <cmath>
#include <iostream>
using namespace std;

class complexe2 {
protected:
  double r;
  double i;
public:
  complexe2 (){
    r = 0;
    i = 0;
    //cout<<" constructeur par complexe par défaut "<<endl;
  }
  complexe2 (double reel , double img){
    r = reel;  i = img;
  }
  complexe2 (const complexe2 & x){
    r = x.r;  i = x.i;
    // cout<<" constructeur par copie complexe par défaut "<<endl;
  }
  ~complexe2 (){
    //cout<<" destructeur complexe "<<endl;
  }
  bool reel_pure();
  bool img_pure();
  complexe2 modify_reel(double reel);
  complexe2  modify_img(double img);
  double  module();
  complexe2 conjugue();
  double reel() const;
  double img() const;
  complexe2 operator + (complexe2);
  complexe2 operator - ( complexe2);
  complexe2 operator * ( complexe2);
  complexe2 operator / ( complexe2);
  complexe2 & operator = (const complexe2 &);
  bool operator < (complexe2);
  bool operator > (complexe2);
  bool operator == (complexe2);
  bool operator != (complexe2);
  friend ostream & operator<<(ostream &, const complexe2 &);
  friend complexe2 operator *(double, const complexe2 &);
  int testu_1();
  int testu_2();
  int testu_3();
  int all_testsu();
};

class comp_unite2 : public complexe2 {
  double theta;
public:
  comp_unite2 (){ // fait automatiquement
    theta =0;
  }
  comp_unite2 (double tinit){
    r = cos(tinit);
    i = sin(tinit);
    theta = tinit;
  }
  comp_unite2 (const comp_unite2 & x): complexe2(x){
     theta = x.theta; 
   }
  ~comp_unite2 (){
  }
  comp_unite2 modify_theta(double theta);
  comp_unite2 eval();
  comp_unite2 conjugue();
  comp_unite2 operator * ( comp_unite2);
  comp_unite2 & operator = (const comp_unite2 &);
};



#endif
